<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui"><title>Sécurisez votre application avec WebAuthn</title><link rel="stylesheet" href="node_modules/reveal.js/dist/reset.css"><link rel="stylesheet" href="node_modules/reveal.js/dist/reveal.css"><link rel="stylesheet" href="node_modules/reveal.js/dist/theme/black.css" id="theme"><!--This CSS is generated by the Asciidoctor reveal.js converter to further integrate AsciiDoc's existing semantic with reveal.js--><style type="text/css">.reveal div.right {
  float: right
}

/* source blocks */
.reveal .listingblock.stretch > .content {
  height: 100%
}

.reveal .listingblock.stretch > .content > pre {
  height: 100%
}

.reveal .listingblock.stretch > .content > pre > code {
  height: 100%;
  max-height: 100%
}

/* auto-animate feature */
/* hide the scrollbar when auto-animating source blocks */
.reveal pre[data-auto-animate-target] {
  overflow: hidden;
}

.reveal pre[data-auto-animate-target] code {
  overflow: hidden;
}

/* add a min width to avoid horizontal shift on line numbers */
code.hljs .hljs-ln-line.hljs-ln-n {
  min-width: 1.25em;
}

/* tables */
table {
  border-collapse: collapse;
  border-spacing: 0
}

table {
  margin-bottom: 1.25em;
  border: solid 1px #dedede
}

table thead tr th, table thead tr td, table tfoot tr th, table tfoot tr td {
  padding: .5em .625em .625em;
  font-size: inherit;
  text-align: left
}

table tr th, table tr td {
  padding: .5625em .625em;
  font-size: inherit
}

table thead tr th, table tfoot tr th, table tbody tr td, table tr td, table tfoot tr td {
  display: table-cell;
  line-height: 1.6
}

td.tableblock > .content {
  margin-bottom: 1.25em
}

td.tableblock > .content > :last-child {
  margin-bottom: -1.25em
}

table.tableblock, th.tableblock, td.tableblock {
  border: 0 solid #dedede
}

table.grid-all > thead > tr > .tableblock, table.grid-all > tbody > tr > .tableblock {
  border-width: 0 1px 1px 0
}

table.grid-all > tfoot > tr > .tableblock {
  border-width: 1px 1px 0 0
}

table.grid-cols > * > tr > .tableblock {
  border-width: 0 1px 0 0
}

table.grid-rows > thead > tr > .tableblock, table.grid-rows > tbody > tr > .tableblock {
  border-width: 0 0 1px
}

table.grid-rows > tfoot > tr > .tableblock {
  border-width: 1px 0 0
}

table.grid-all > * > tr > .tableblock:last-child, table.grid-cols > * > tr > .tableblock:last-child {
  border-right-width: 0
}

table.grid-all > tbody > tr:last-child > .tableblock, table.grid-all > thead:last-child > tr > .tableblock, table.grid-rows > tbody > tr:last-child > .tableblock, table.grid-rows > thead:last-child > tr > .tableblock {
  border-bottom-width: 0
}

table.frame-all {
  border-width: 1px
}

table.frame-sides {
  border-width: 0 1px
}

table.frame-topbot, table.frame-ends {
  border-width: 1px 0
}

.reveal table th.halign-left, .reveal table td.halign-left {
  text-align: left
}

.reveal table th.halign-right, .reveal table td.halign-right {
  text-align: right
}

.reveal table th.halign-center, .reveal table td.halign-center {
  text-align: center
}

.reveal table th.valign-top, .reveal table td.valign-top {
  vertical-align: top
}

.reveal table th.valign-bottom, .reveal table td.valign-bottom {
  vertical-align: bottom
}

.reveal table th.valign-middle, .reveal table td.valign-middle {
  vertical-align: middle
}

table thead th, table tfoot th {
  font-weight: bold
}

tbody tr th {
  display: table-cell;
  line-height: 1.6
}

tbody tr th, tbody tr th p, tfoot tr th, tfoot tr th p {
  font-weight: bold
}

thead {
  display: table-header-group
}

.reveal table.grid-none th, .reveal table.grid-none td {
  border-bottom: 0 !important
}

/* kbd macro */
kbd {
  font-family: "Droid Sans Mono", "DejaVu Sans Mono", monospace;
  display: inline-block;
  color: rgba(0, 0, 0, .8);
  font-size: .65em;
  line-height: 1.45;
  background: #f7f7f7;
  border: 1px solid #ccc;
  -webkit-border-radius: 3px;
  border-radius: 3px;
  -webkit-box-shadow: 0 1px 0 rgba(0, 0, 0, .2), 0 0 0 .1em white inset;
  box-shadow: 0 1px 0 rgba(0, 0, 0, .2), 0 0 0 .1em #fff inset;
  margin: 0 .15em;
  padding: .2em .5em;
  vertical-align: middle;
  position: relative;
  top: -.1em;
  white-space: nowrap
}

.keyseq kbd:first-child {
  margin-left: 0
}

.keyseq kbd:last-child {
  margin-right: 0
}

/* callouts */
.conum[data-value] {
  display: inline-block;
  color: #fff !important;
  background: rgba(0, 0, 0, .8);
  -webkit-border-radius: 50%;
  border-radius: 50%;
  text-align: center;
  font-size: .75em;
  width: 1.67em;
  height: 1.67em;
  line-height: 1.67em;
  font-family: "Open Sans", "DejaVu Sans", sans-serif;
  font-style: normal;
  font-weight: bold
}

.conum[data-value] * {
  color: #fff !important
}

.conum[data-value] + b {
  display: none
}

.conum[data-value]:after {
  content: attr(data-value)
}

pre .conum[data-value] {
  position: relative;
  top: -.125em
}

b.conum * {
  color: inherit !important
}

.conum:not([data-value]):empty {
  display: none
}

/* Callout list */
.hdlist > table, .colist > table {
  border: 0;
  background: none
}

.hdlist > table > tbody > tr, .colist > table > tbody > tr {
  background: none
}

td.hdlist1, td.hdlist2 {
  vertical-align: top;
  padding: 0 .625em
}

td.hdlist1 {
  font-weight: bold;
  padding-bottom: 1.25em
}

/* Disabled from Asciidoctor CSS because it caused callout list to go under the
 * source listing when .stretch is applied (see #335)
 * .literalblock+.colist,.listingblock+.colist{margin-top:-.5em} */
.colist td:not([class]):first-child {
  padding: .4em .75em 0;
  line-height: 1;
  vertical-align: top
}

.colist td:not([class]):first-child img {
  max-width: none
}

.colist td:not([class]):last-child {
  padding: .25em 0
}

/* Override Asciidoctor CSS that causes issues with reveal.js features */
.reveal .hljs table {
  border: 0
}

/* Callout list rows would have a bottom border with some reveal.js themes (see #335) */
.reveal .colist > table th, .reveal .colist > table td {
  border-bottom: 0
}

/* Fixes line height with Highlight.js source listing when linenums enabled (see #331) */
.reveal .hljs table thead tr th, .reveal .hljs table tfoot tr th, .reveal .hljs table tbody tr td, .reveal .hljs table tr td, .reveal .hljs table tfoot tr td {
  line-height: inherit
}

/* Columns layout */
.columns .slide-content {
  display: flex;
}

.columns.wrap .slide-content {
  flex-wrap: wrap;
}

.columns.is-vcentered .slide-content {
  align-items: center;
}

.columns .slide-content > .column {
  display: block;
  flex-basis: 0;
  flex-grow: 1;
  flex-shrink: 1;
}

.columns .slide-content > .column > * {
  padding: .75rem;
}

/* See #353 */
.columns.wrap .slide-content > .column {
  flex-basis: auto;
}

.columns .slide-content > .column.is-full {
  flex: none;
  width: 100%;
}

.columns .slide-content > .column.is-four-fifths {
  flex: none;
  width: 80%;
}

.columns .slide-content > .column.is-three-quarters {
  flex: none;
  width: 75%;
}

.columns .slide-content > .column.is-two-thirds {
  flex: none;
  width: 66.6666%;
}

.columns .slide-content > .column.is-three-fifths {
  flex: none;
  width: 60%;
}

.columns .slide-content > .column.is-half {
  flex: none;
  width: 50%;
}

.columns .slide-content > .column.is-two-fifths {
  flex: none;
  width: 40%;
}

.columns .slide-content > .column.is-one-third {
  flex: none;
  width: 33.3333%;
}

.columns .slide-content > .column.is-one-quarter {
  flex: none;
  width: 25%;
}

.columns .slide-content > .column.is-one-fifth {
  flex: none;
  width: 20%;
}

.columns .slide-content > .column.has-text-left {
  text-align: left;
}

.columns .slide-content > .column.has-text-justified {
  text-align: justify;
}

.columns .slide-content > .column.has-text-right {
  text-align: right;
}

.columns .slide-content > .column.has-text-left {
  text-align: left;
}

.columns .slide-content > .column.has-text-justified {
  text-align: justify;
}

.columns .slide-content > .column.has-text-right {
  text-align: right;
}

.text-left {
  text-align: left !important
}

.text-right {
  text-align: right !important
}

.text-center {
  text-align: center !important
}

.text-justify {
  text-align: justify !important
}

.footnotes {
  border-top: 1px solid rgba(0, 0, 0, 0.2);
  padding: 0.5em 0 0 0;
  font-size: 0.65em;
  margin-top: 4em;
}

.byline {
  font-size:.8em
}
ul.byline {
  list-style-type: none;
}
ul.byline li + li {
  margin-top: 0.25em;
}
</style><link rel="stylesheet" href="slides.css"></head><body><div class="reveal"><div class="slides"><section class="title" data-state="title"><h1>Sécurisez votre application avec WebAuthn</h1></section><section id="_intro" class="intro"><h2>Intro</h2><div class="slide-content"><div class="imageblock me"><img src="images/alocquet-benefiz.jpg" alt="alocquet benefiz"></div>
<div class="imageblock"><img src="images/benefiz.png" alt="benefiz" width="150"></div>
<aside class="notes"><div class="ulist"><ul><li><p>benefiz</p></li><li><p>Zenika / authent CI Monaco</p></li></ul></div></aside></div></section>
<section><section id="_mot_de_passe" class="subtitle"><h2>Mot de passe ?</h2></section><section id="_fail_top_10"><h2>FAIL - Top 10</h2><div class="slide-content"><div class="imageblock stretch"><img src="images/top10.png" alt="top10" height="100%"></div></div></section><section id="_fail_post_it" class="hidden"><div class="slide-content"><div class="imageblock"><img src="images/fail-tf1.jpg" alt="fail tf1" width="60%"></div></div></section><section id="_fail_post_it_2" class="hidden"><div class="slide-content"><div class="videoblock stretch"><video src="images/fail-azerty.mp4" width="100%" height="100%" data-autoplay controls loop>Your browser does not support the video tag.</video></div></div></section><section id="_fail_mot_de_passe_en_clair"><h2>FAIL - Mot de passe en clair</h2><div class="slide-content"><div class="imageblock"><img src="images/password-clair.png" alt="password clair"></div></div></section><section id="_fail_i_have_been_pwned"><h2>FAIL - I have been Pwned</h2><div class="slide-content"><div class="paragraph"><p><a href="https://haveibeenpwned.com/" class="bare">https://haveibeenpwned.com/</a></p></div></div></section><section id="_il_manque_quoi" class="subtitle"><h2>Il manque quoi ?</h2></section><section id="_moyen_dauthentification"><h2>Moyen d&#8217;authentification</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>Ce que l&#8217;on connaît</p></li><li class="fragment"><p>Ce que l&#8217;on possède</p></li><li class="fragment"><p>Ce que l&#8217;on est</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Exemples dans la vie réelle : signature, CI
Ce que l&#8217;on est : biométrie : empreinte digitale, reco faciale et reco du vivant
Autre : où on est (géolocalisation), ce qu&#8217;on sait faire (signature)</p></div></aside></div></section></section>
<section><section id="_autres_solutions_que_le_mot_de_passe" class="subtitle"><h2>Autres solutions que le mot de passe ?</h2></section><section id="_double_authentification"><h2>Double authentification</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>Mot de passe</p></li><li class="fragment"><p>OTP</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Objectif : avoir plusieurs moyen d&#8217;authentification</p></div></aside></div></section><section id="_otp_sms"><h2>OTP : SMS</h2><div class="slide-content"><div class="imageblock stretch"><img src="images/twitter.png" alt="twitter" height="100%"></div></div></section><section id="_totp"><h2>TOTP</h2><div class="slide-content"><div class="imageblock"><img src="images/otp.png" alt="otp" width="30%"></div></div></section><section id="_tls"><h2>TLS</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>Cryptographie asymétrique</p></li><li class="fragment"><p>Certificat + clé privée</p></li><li class="fragment"><p>Exemple carte CPS</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Très sécurisé
Pas user friendly</p></div></aside></div></section></section>
<section><section id="_fido"><h2>FIDO</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>Fast IDentity Online</p></li><li class="fragment"><p>Standards</p></li><li class="fragment"><p>FIDO 2</p><div class="ulist"><ul><li><p>Webauthn : standard W3C</p></li><li><p>CTAP : communication avec authentificateur</p></li></ul></div></li></ul></div></div></section><section id="_authentificateur"><h2>Authentificateur</h2><div class="slide-content"><img src="images/feitian_key.jpg" style="position: absolute;right: 10px;bottom:-100px;width: 20%;"/>
<div class="ulist"><ul><li class="fragment"><p>YubiKey, SoloKey, Android, MBP</p></li><li class="fragment"><p>Hardware</p></li><li class="fragment"><p>Cryptographie</p></li><li class="fragment"><p>USB, NFC, BLE</p></li></ul></div></div></section><section id="_webauthn"><h2>Webauthn</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>credentials.create()</p></li><li class="fragment"><p>credentials.get()</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Webauthn : API d&#8217;utilisation de clé publiques dans le browser</p></div></aside></div></section><section id="_can_i_use"><h2>Can I use ?</h2><div class="slide-content"><div class="imageblock"><img src="images/caniuse.jpeg" alt="caniuse"></div></div></section><section id="_usecases"><h2>UseCases</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>Double authentification</p></li><li class="fragment"><p>Authentication sans login / mot de passe</p></li></ul></div></div></section><section id="_rappels_crypto"><h2>(Rappels crypto)</h2></section><section id="_chiffrement_symétrique"><h2>Chiffrement symétrique</h2><div class="slide-content"><div class="imageblock kroki"><img src="https://kroki.io/plantuml/svg/eNqFjDEOgjAYRvee4g87CQVE4uBgjBfQnZTyVRqgJW0xxBPpObiYgwnByfW9732-02YUTgw0WGNl6-wACm4C86txwnQeI6XJBjajJr77IVBi6sPFmnDVTxBPtx-QQZh7j5N1Ddyt1bIz8J44Y6uj6IyHnedoi5TI6iQv9wUv84SjhuJ1mUEi50UOriLGvhXFLj7SvzkdaBCV7Jd35SHd8gr4AKjTWIM=" alt="Diagram"></div></div></section><section id="_déchiffrement"><h2>Déchiffrement</h2><div class="slide-content"><div class="imageblock kroki"><img src="https://kroki.io/plantuml/svg/eNqFjDEOgjAYRvee4g87CYWKxMHBGC-gOynlqxCgJW0xxBPpObiYgwnByfW9l-e71ozSyYEGa6xqnB1AwU1gfjVOms5jpDTZwHpsie9-CLSc-nCxJlzbJ4in2wdUkObe42RdDXdrWtUZeE-csdVRdMbDznO0RVpmVSKKfc4LkXBU0LwqMigIngtwHTH2L6G4j4_0fRMdaJCl6pd36aHc8gr4AOW8WJ0=" alt="Diagram"></div></div></section><section id="_cryptographie_asymétrique"><h2>Cryptographie asymétrique</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>clé privée  / clé publique</p></li><li class="fragment"><p>chiffrement  / signature</p></li></ul></div></div></section><section id="_chiffrement_déchiffrement"><h2>Chiffrement / Déchiffrement</h2><div class="slide-content"><div class="imageblock kroki"><img src="https://kroki.io/plantuml/svg/eNp1z00OgjAQhuF9TzFhT0IL_sSFC2O8gO6MMaUM0lBabAsh3ohzcDHBBcEF2_fJfMm4UuqaW15BZbQRhTUVgrcNEjeL5bp0WAOLFjGrJdDNX8GcN8pfjPZX-UGgbLmBwnP9UngyNkN7K6QoNToHlJDZIDhja7ouAD7Bouc8TqNkv9v-iK1TvLKWEEIhtOERGBxAqKF_1k2q5Hv8NIZQjZDMYGU79Dgd3AuZZagfE38BDihkSQ==" alt="Diagram"></div></div></section><section id="_signature_vérification"><h2>Signature / Vérification</h2><div class="slide-content"><div class="imageblock kroki"><img src="https://kroki.io/plantuml/svg/eNp10D8OgjAUx_G9p3hhJ4GCf-LgYIwX0M0YU9qHNJS2tkCIN-IcXExwIDiwfj95v-H5UmrLHKugMtrwwpkKoXYNEj-LY7r0aIFGiyishHjzVzBnjaovRtdX-UGI6XIDec30S-HJOIHuVkheavQeYkJmg-CMrem6ANgEi56zJIvS_W77I7pOycpaSkgMoQuPQOEAXA390zrZDj2SBEI19nTuTabke_zAeHAvpBCoH5N_ARqLZEk=" alt="Diagram"></div></div></section><section id="_principe_de_webauthn"><h2>Principe de Webauthn</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>Création d&#8217;un challenge</p></li><li class="fragment"><p>Signature du challenge / clé privée</p></li><li class="fragment"><p>Vérification challenge / clé publique</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Faire un rappel sur la crypto asymétrique</p></div></aside></div></section></section>
<section><section id="_enregistrement" class="subtitle"><h2>Enregistrement</h2></section><section id="_enregistrement_2"><h2>Enregistrement</h2><div class="slide-content"><object style="width:90%; height:auto" type="image/svg+xml" data="images/register.svg"> </object></div></section><section id="_démo" class="subtitle"><h2>Démo</h2></section></section>
<section><section id="_authentification" class="subtitle"><h2>Authentification</h2></section><section id="_authentification_2"><h2>Authentification</h2><div class="slide-content"><object style="width:90%; height:auto" type="image/svg+xml" data="images/authent.svg"> </object>
<aside class="notes"><div class="ulist"><ul><li><p>anti phishing</p></li><li><p>pas d&#8217;info perso comme le password</p></li><li><p>ce que l&#8217;on possède</p></li></ul></div></aside></div></section><section id="_démo_2" class="subtitle"><h2>Démo</h2></section></section>
<section><section id="_passwordless" class="subtitle"><h2>Passwordless</h2></section><section id="_persistence_des_clés"><h2>Persistence des clés</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>Clé publique stockée par le serveur</p></li><li class="fragment"><p>Clé privée</p><div class="ulist"><ul><li><p>générée à la volée / wrappée</p></li><li><p>stockée sur l&#8217;authentificateur</p></li></ul></div></li></ul></div>
<aside class="notes"><div class="ulist"><ul><li><p>Stockage limité de clés privées</p></li><li><p>Stockage sécurisé couteux</p></li><li><p>MAIS le stockage permet le passwordless</p></li></ul></div></aside></div></section><section id="_démo_3" class="subtitle"><h2>Démo</h2></section></section>
<section id="_intégrations" class="subtitle"><h2>Intégrations</h2><div class="slide-content"><div class="ulist"><ul><li class="fragment"><p>Spring security</p></li><li class="fragment"><p>Keycloak</p></li></ul></div>
<aside class="notes"><div class="ulist"><ul><li><p>prepa : new realm, activer registration, authenticator (creer, activer), activer webauthn au register</p></li><li><p>Relying Party ID = nom de domaine</p></li><li><p>Attestation Conveyance Preference : direct / indirect / none : demande d&#8217;une attestation au register</p></li><li><p>Authenticator Attachment : touchId vs YubiKey</p></li></ul></div></aside></div></section>
<section id="_merci" class="subtitle"><h2>Merci</h2><div class="slide-content"><div class="paragraph"><p>Questions ?</p></div>
 <div id="footer" class="footer">
     <span class="element">#webauthn</span>
     <span class="element"><img src="images/benefiz.svg" width="150px"/></span>
     <span class="element">@LocquetArnaud</span>
 </div>
  <script type="text/javascript">
     window.addEventListener("load", function() {
         revealDiv = document.querySelector("body div.reveal")
         footer = document.getElementById("footer");
         revealDiv.appendChild(footer);
     } );
 </script></div></section></div></div><script src="node_modules/reveal.js/dist/reveal.js"></script><script>Array.prototype.slice.call(document.querySelectorAll('.slides section')).forEach(function(slide) {
  if (slide.getAttribute('data-background-color')) return;
  // user needs to explicitly say he wants CSS color to override otherwise we might break custom css or theme (#226)
  if (!(slide.classList.contains('canvas') || slide.classList.contains('background'))) return;
  var bgColor = getComputedStyle(slide).backgroundColor;
  if (bgColor !== 'rgba(0, 0, 0, 0)' && bgColor !== 'transparent') {
    slide.setAttribute('data-background-color', bgColor);
    slide.style.backgroundColor = 'transparent';
  }
});

// More info about config & dependencies:
// - https://github.com/hakimel/reveal.js#configuration
// - https://github.com/hakimel/reveal.js#dependencies
Reveal.initialize({
  // Display presentation control arrows
  controls: true,
  // Help the user learn the controls by providing hints, for example by
  // bouncing the down arrow when they first encounter a vertical slide
  controlsTutorial: true,
  // Determines where controls appear, "edges" or "bottom-right"
  controlsLayout: 'bottom-right',
  // Visibility rule for backwards navigation arrows; "faded", "hidden"
  // or "visible"
  controlsBackArrows: 'faded',
  // Display a presentation progress bar
  progress: true,
  // Display the page number of the current slide
  slideNumber: false,
  // Control which views the slide number displays on
  showSlideNumber: 'all',
  // Add the current slide number to the URL hash so that reloading the
  // page/copying the URL will return you to the same slide
  hash: false,
  // Push each slide change to the browser history. Implies `hash: true`
  history: true,
  // Enable keyboard shortcuts for navigation
  keyboard: true,
  // Enable the slide overview mode
  overview: true,
  // Disables the default reveal.js slide layout so that you can use custom CSS layout
  disableLayout: false,
  // Vertical centering of slides
  center: true,
  // Enables touch navigation on devices with touch input
  touch: true,
  // Loop the presentation
  loop: false,
  // Change the presentation direction to be RTL
  rtl: false,
  // See https://github.com/hakimel/reveal.js/#navigation-mode
  navigationMode: 'default',
  // Randomizes the order of slides each time the presentation loads
  shuffle: false,
  // Turns fragments on and off globally
  fragments: true,
  // Flags whether to include the current fragment in the URL,
  // so that reloading brings you to the same fragment position
  fragmentInURL: false,
  // Flags if the presentation is running in an embedded mode,
  // i.e. contained within a limited portion of the screen
  embedded: false,
  // Flags if we should show a help overlay when the questionmark
  // key is pressed
  help: true,
  // Flags if speaker notes should be visible to all viewers
  showNotes: false,
  // Global override for autolaying embedded media (video/audio/iframe)
  // - null: Media will only autoplay if data-autoplay is present
  // - true: All media will autoplay, regardless of individual setting
  // - false: No media will autoplay, regardless of individual setting
  autoPlayMedia: null,
  // Global override for preloading lazy-loaded iframes
  // - null: Iframes with data-src AND data-preload will be loaded when within
  //   the viewDistance, iframes with only data-src will be loaded when visible
  // - true: All iframes with data-src will be loaded when within the viewDistance
  // - false: All iframes with data-src will be loaded only when visible
  preloadIframes: null,
  // Number of milliseconds between automatically proceeding to the
  // next slide, disabled when set to 0, this value can be overwritten
  // by using a data-autoslide attribute on your slides
  autoSlide: 0,
  // Stop auto-sliding after user input
  autoSlideStoppable: true,
  // Use this method for navigation when auto-sliding
  autoSlideMethod: Reveal.navigateNext,
  // Specify the average time in seconds that you think you will spend
  // presenting each slide. This is used to show a pacing timer in the
  // speaker view
  defaultTiming: 120,
  // Specify the total time in seconds that is available to
  // present.  If this is set to a nonzero value, the pacing
  // timer will work out the time available for each slide,
  // instead of using the defaultTiming value
  totalTime: 0,
  // Specify the minimum amount of time you want to allot to
  // each slide, if using the totalTime calculation method.  If
  // the automated time allocation causes slide pacing to fall
  // below this threshold, then you will see an alert in the
  // speaker notes window
  minimumTimePerSlide: 0,
  // Enable slide navigation via mouse wheel
  mouseWheel: false,
  // Hide cursor if inactive
  hideInactiveCursor: true,
  // Time before the cursor is hidden (in ms)
  hideCursorTime: 5000,
  // Hides the address bar on mobile devices
  hideAddressBar: true,
  // Opens links in an iframe preview overlay
  // Add `data-preview-link` and `data-preview-link="false"` to customise each link
  // individually
  previewLinks: false,
  // Transition style (e.g., none, fade, slide, convex, concave, zoom)
  transition: 'slide',
  // Transition speed (e.g., default, fast, slow)
  transitionSpeed: 'default',
  // Transition style for full page slide backgrounds (e.g., none, fade, slide, convex, concave, zoom)
  backgroundTransition: 'fade',
  // Number of slides away from the current that are visible
  viewDistance: 3,
  // Number of slides away from the current that are visible on mobile
  // devices. It is advisable to set this to a lower number than
  // viewDistance in order to save resources.
  mobileViewDistance: 3,
  // Parallax background image (e.g., "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'")
  parallaxBackgroundImage: '',
  // Parallax background size in CSS syntax (e.g., "2100px 900px")
  parallaxBackgroundSize: '',
  // Number of pixels to move the parallax background per slide
  // - Calculated automatically unless specified
  // - Set to 0 to disable movement along an axis
  parallaxBackgroundHorizontal: null,
  parallaxBackgroundVertical: null,
  // The display mode that will be used to show slides
  display: 'block',

  // The "normal" size of the presentation, aspect ratio will be preserved
  // when the presentation is scaled to fit different resolutions. Can be
  // specified using percentage units.
  width: 960,
  height: 700,

  // Factor of the display size that should remain empty around the content
  margin: 0.1,

  // Bounds for smallest/largest possible scale to apply to content
  minScale: 0.2,
  maxScale: 1.5,

  // PDF Export Options
  // Put each fragment on a separate page
  pdfSeparateFragments: true,
  // For slides that do not fit on a page, max number of pages
  pdfMaxPagesPerSlide: 1,

  // Optional libraries used to extend on reveal.js
  dependencies: [
      { src: 'node_modules/reveal.js/plugin/zoom/zoom.js', async: true, callback: function () { Reveal.registerPlugin(RevealZoom) } },
      { src: 'node_modules/reveal.js/plugin/notes/notes.js', async: true, callback: function () { Reveal.registerPlugin(RevealNotes) } }
  ],
});</script><script>var dom = {};
dom.slides = document.querySelector('.reveal .slides');

function getRemainingHeight(element, slideElement, height) {
  height = height || 0;
  if (element) {
    var newHeight, oldHeight = element.style.height;
    // Change the .stretch element height to 0 in order find the height of all
    // the other elements
    element.style.height = '0px';
    // In Overview mode, the parent (.slide) height is set of 700px.
    // Restore it temporarily to its natural height.
    slideElement.style.height = 'auto';
    newHeight = height - slideElement.offsetHeight;
    // Restore the old height, just in case
    element.style.height = oldHeight + 'px';
    // Clear the parent (.slide) height. .removeProperty works in IE9+
    slideElement.style.removeProperty('height');
    return newHeight;
  }
  return height;
}

function layoutSlideContents(width, height) {
  // Handle sizing of elements with the 'stretch' class
  toArray(dom.slides.querySelectorAll('section .stretch')).forEach(function (element) {
    // Determine how much vertical space we can use
    var limit = 5; // hard limit
    var parent = element.parentNode;
    while (parent.nodeName !== 'SECTION' && limit > 0) {
      parent = parent.parentNode;
      limit--;
    }
    if (limit === 0) {
      // unable to find parent, aborting!
      return;
    }
    var remainingHeight = getRemainingHeight(element, parent, height);
    // Consider the aspect ratio of media elements
    if (/(img|video)/gi.test(element.nodeName)) {
      var nw = element.naturalWidth || element.videoWidth, nh = element.naturalHeight || element.videoHeight;
      var es = Math.min(width / nw, remainingHeight / nh);
      element.style.width = (nw * es) + 'px';
      element.style.height = (nh * es) + 'px';
    } else {
      element.style.width = width + 'px';
      element.style.height = remainingHeight + 'px';
    }
  });
}

function toArray(o) {
  return Array.prototype.slice.call(o);
}

Reveal.addEventListener('slidechanged', function () {
  layoutSlideContents(960, 700)
});
Reveal.addEventListener('ready', function () {
  layoutSlideContents(960, 700)
});
Reveal.addEventListener('resize', function () {
  layoutSlideContents(960, 700)
});</script><script type="text/javascript">
    window.addEventListener("load", function() {
Reveal.configure({
    keyboard: {
       39: 'next', // Right Arrow
       37: 'prev'  // Left Arrow
    }
  })});

  </script>

<script src="plugins/spotlight.js"></script>
<script src="plugins/svg.js"></script></body></html>